"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n    margin-right: 20px;\n    width: 15px;\n    height: 15px;\n    border-radius: 50%;\n    outline: none;\n    border: none;\n    text-align: center;\n    border: none;\n    margin-right: 26px;\n    outline: none;\n    transition: 500ms;\n    border-radius: 50px;\n    user-select: none;\n    background: transparent;\n    border: 2px solid #adece1;\n    color: transparent;\n    /* background: white;\n    color: transparent; */\n\n    &:last-child {\n        margin-right: 0px;\n    }\n\n    &:focus {\n        outline: none !important;\n\n        /* color: transparent !important;\n        background: #dee3e4 !important; */\n\n        background: transparent !important;\n        border: 2px solid #adece1 !important;\n    }\n\n    &.full {\n        background-color: white !important;\n        color: transparent !important;\n        border: 2px solid white;\n    }\n\n    &::-webkit-outer-spin-button,\n    &::-webkit-inner-spin-button {\n        -webkit-appearance: none;\n        margin: 0;\n    }\n\n    &:-moz-selection {\n        color: transparent;\n        background: transparent;\n    }\n\n    &[type='number'] {\n        -moz-appearance: textfield;\n    }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n    display: flex;\n    flex-direction: row;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var PassCodeInput = function PassCodeInput(_ref) {
  var type = _ref.type,
      fields = _ref.fields,
      correctPassword = _ref.correctPassword;
  var INPUTS_NUM = fields || 4;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      inputValue = _useState4[0],
      setInputValue = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = _slicedToArray(_useState5, 2),
      inputElements = _useState6[0],
      setInputElements = _useState6[1];

  (0, _react.useEffect)(function () {
    var parent = document.getElementById('pass-code-input-wrapper');
    setInputElements(parent.children);
    parent.children[0].focus();
  }, []);
  _react.useEffect;

  var removeInputValue = function removeInputValue(elem) {
    elem.removeAttribute('value');
    elem.value = '';
  };

  var makeFocused = function makeFocused(elem, id) {
    elem.focus();
    setFocused(id);
  };

  (0, _react.useEffect)(function () {
    if (focused === fields) {
      var validCode = correctPassword(inputValue.join(''));

      if (!validCode) {
        setTimeout(function () {
          setInputValue([]);
          var parent = document.getElementById('pass-code-input-wrapper');
          setFocused(0);
          setInputElements(parent.children);

          var _iterator = _createForOfIteratorHelper(parent.children),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var child = _step.value;
              child.value = '';
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }

          parent.children[0].focus();
        }, 300);
      }
    }
  }, [focused]);

  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(e) {
      var currentFocus;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(e.target.value.length > 1)) {
                _context.next = 4;
                break;
              }

              e.target.value = e.target.value[0];
              e.preventDefault();
              return _context.abrupt("return");

            case 4:
              if (!(focused < INPUTS_NUM - 1)) {
                _context.next = 10;
                break;
              }

              currentFocus = focused;
              makeFocused(e.target.nextSibling, currentFocus + 1);
              setInputValue(function (inputValue) {
                return [].concat(_toConsumableArray(inputValue), [e.target.value]);
              });
              _context.next = 16;
              break;

            case 10:
              if (!(focused === INPUTS_NUM - 1)) {
                _context.next = 16;
                break;
              }

              _context.next = 13;
              return setInputValue(function (inputValue) {
                return [].concat(_toConsumableArray(inputValue), [e.target.value]);
              });

            case 13:
              //Remove if wanted to manipulate after entering last char
              inputElements[focused].blur();
              inputElements[focused].classList.add('full');
              setFocused(4);

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function onInputChange(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleKeyDown = function handleKeyDown(event) {
    if (event.keyCode === 8 || event.keyCode === 46) {
      var previousSiblingId = focused - 1;
      var newInput = inputValue;
      newInput.pop();
      setInputValue(newInput);

      if (focused === INPUTS_NUM - 1) {
        if (event.target.value === '') {
          makeFocused(inputElements[previousSiblingId], previousSiblingId);
          removeInputValue(inputElements[previousSiblingId]);
        }

        inputElements[focused].classList.remove('full');
        removeInputValue(inputElements[focused]);
        event.target.value = '';
      } else if (previousSiblingId >= 0) {
        removeInputValue(inputElements[previousSiblingId]);
        removeInputValue(inputElements[focused]);
        makeFocused(inputElements[previousSiblingId], previousSiblingId);
        event.target.value = '';
      } else {
        makeFocused(inputElements[0], 0);
        removeInputValue(inputElements[1]);
        removeInputValue(inputElements[0]);
        setInputValue([]);
      }

      event.preventDefault();
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, inputValue !== undefined && /*#__PURE__*/_react["default"].createElement(Wrapper, {
    id: "pass-code-input-wrapper"
  }, _toConsumableArray(Array(INPUTS_NUM)).map(function (e, i) {
    return /*#__PURE__*/_react["default"].createElement(InputField, {
      type: type,
      className: inputValue[i] ? 'full' : '',
      value: inputValue[i],
      onChange: onInputChange,
      onKeyDown: handleKeyDown
    });
  })));
};

var Wrapper = _styledComponents["default"].div(_templateObject());

var InputField = _styledComponents["default"].input(_templateObject2());

var _default = PassCodeInput;
exports["default"] = _default;
